<?php
/**
* SystemComponent Class - change settings in the function 'getSettings', below
*/
class SystemComponent {

    var $settings;

	/* Change settings here */
	function getSettings() {
	
		// Database settings 

		$settings['dbhost'] = 'localhost';		// DB host
		$settings['dbusername'] = 'root';		// DB username
		$settings['dbpassword'] = 'nopassword';		// DB password
		$settings['dbname'] = 'cibiv_teaching';		// Database name

	    return $settings;

    }

	/**
	* SystemComponent constructor
	*/
	function SystemComponent() {
		_set_error_handler( array(&$this, 'throwError'));
	}

	/**
	* Create a new DB connection, or continues an existing
	* one if present
	*/
	function &DB(){
		static $dbConnect;
		if (!isset($dbConnect)){
			require_once('DbConnector.php');
			$dbConnect = new DbConnector;
		}
		return $dbConnect;
	}
	
	/**
	* Get the current URL
	*/
	function getURL(){
		$url = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?';
		foreach ($_GET as $key=>$val){
			$url.= $key.'='.$val.'&';
		}
		if (substr($url,strlen($url) - 1,1) == '&'){$url = substr($url,0,strlen($url) - 1);}
		return $url;
	}
	
	/**
	* Change param $param to have value $newValue in the querystring
	*/	
	function modURL($param,$newValue,$url = ''){
		
		if ($url == ''){
			$found = false;
			$url = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?';
	
			foreach ($_GET as $key=>$val){
				if ($key == $param){
					$url.= $key.'='.$newValue.'&';
					$found = true;
				}else{
					$url.= $key.'='.$val.'&';
				}
			}
			
			if (substr($url,strlen($url) - 1,1) == '&'){$url = substr($url,0,strlen($url) - 1);}
			if ($found == false){$url.= '&'.$param.'='.$newValue;}
			
		}else{
			$url = preg_replace("/$param=[A-Za-z0-9]*/","$param=$newValue",$url);
			if (!strstr($url,'?')){$url.= '?';}
			if (!strstr($url,"$param=$newValue")){$url.= "&$param=$newValue";}
		}
	
		
		return $url;		
	}
	
	/**
	* Get the URL of the page with given ID number
	*/	
	function getPageURL($id){
		//$settings = SystemComponent::getSettings();
		require_once('DbConnector.php');
		require_once('Validator.php');

		$validator = new Validator();
		$connector = SystemComponent::DB();

		if (!$validator->validateNumber($id)){return false;}
		$result = $connector->getResult('SELECT filename,extension,section FROM cmspages WHERE ID = "'.$id.'"');
		$sectionResult = $connector->getResult('SELECT name FROM cmssections WHERE ID = '.$result['section']);

		if ($sectionResult['name'] == 'none'){
			return stripslashes($_SESSION['_SITEROOT']).'/pages/'.$result['filename'].$result['extension'];			
		}else{
			return stripslashes($_SESSION['_SITEROOT']).'/pages/'.$sectionResult['name'].'/'.$result['filename'].$result['extension'];
		}
	}
	
	/* Severity is 1 or 2 (fatal or non-fatal) */
	function errormsg($message,$severity = 1){
		SystemComponent::throwError($severity, $message, basename($_SERVER['PHP_SELF']), null, null);
		if ($severity == 1){die();}
	}
	
	/**
	* For internal system errors
	*/
	function throwError ($error_type, $error_msg, $error_file, $error_line = null, $error_context = null) {
		
		// Display messages
		if ($error_type != 888){
			echo '<table border=1 border="1" cellpadding="2" cellspacing="0" bordercolor="#C8C8C8" bgcolor="#F0F0F0"><tr><td bordercolor="#F0F0F0">';
			echo '<font size=2 face="verdana">Sorry, a mishap has occurred.</font> ';		
			if ($error_file != null){
				echo "<br><font size=1 face='verdana'>FILE: $error_file, LINE: $error_line</font>";
			}
			echo '<br><font size="1">ERROR: '.$error_msg.'</font>';
			echo '<br><center><font size="1"><a href="javascript:history.back(1)">Back</a> | ';
			echo '<a href="javascript:location.reload()">Refresh</a></font></center>';
			//print_r($error_context);
			echo '<br></td></tr></table><br>';
		}

	}

}

/**
* set_error_handler that works with all versions of php 
* Source: http://mojavi.org/forum/viewtopic.php?t=57&sid=896a45f2b500927c634d3f8d4fec67d4
*/
function _set_error_handler($arg) 
{ 
    if (is_array($arg)) { 
        if (phpversion() >= '4.3.0') { 
            set_error_handler($arg); 
        } else { 
            $GLOBALS['_error_handler_hook_obj'] =& $arg[0]; 
            $GLOBALS['_error_handler_hook_method'] = $arg[1]; 
            set_error_handler('error_handler_callback'); 
        } 
    } else if (is_string($arg)) { 
        set_error_handler($arg); 
    } else { 
        trigger_error("Wrong argument type for _set_error_handler", E_USER_ERROR); 
    } 
} 

?>
