<?php
////////////////////////////////////////////////////////////////////////////////////////
// Class: DbConnector
// Purpose: Connect to a database, MySQL version
///////////////////////////////////////////////////////////////////////////////////////
require_once 'SystemComponent.php';
require_once 'Validator.php';

class DbConnector extends SystemComponent {

var $theQuery;
var $results;
var $link;
var $first = 0,$limit = 0;

var $withPag;
var $paginatorObj;
var $pagNumResults;

/**
* The database layer class - MySQL Version
*
* Handles connecting to the database, as well as querying
* and various other common operations
*
*/

function DbConnector(){
	// Load settings from parent class
	$settings = SystemComponent::getSettings();

	// Set the error handler
	//_set_error_handler( array(&$this, 'throwError'));
	
	// Get the main settings from the array we just loaded
	$host = $settings['dbhost'];
	$db = $settings['dbname'];
	$user = $settings['dbusername'];
	$pass = $settings['dbpassword'];

	// Connect to the database
	$this->link = mysql_connect($host, $user, $pass);
	mysql_select_db($db);
	register_shutdown_function(array(&$this, 'close'));

}

//*** Function: query, Purpose: Execute a database query ***
function query($query) {
	$this->theQuery = $query;
	return mysql_query($query, $this->link);

}

function get_course_record($course_id)
{
	$result = $this->query("select * from courses where LVA_ID = '$course_id'");
	return $this->fetchArray($result); 

}

function setFirst($rowNum){
	// VALIDATE
	if ($rowNum > 0){
		$this->first = $rowNum; // Minus one to allow indexing from 1
	}
}

function setLimit($rowNum){
	$this->limit = $rowNum;	
}

//*** Function: movePointer, Purpose: Move the internal pointer of a result ***
function movePointer($result,$position){
	mysql_data_seek($result, $position);
	return true;
}

//*** Function: getResult, Purpose: Get a single record from the DB ***
function getResult($query){
	$doQuery = $this->query($query);
	//$this->results = $doQuery;
	return $this->fetchArray($doQuery);
}

//*** Function: getResults, Purpose: Return the current result object ***
function getResults() {
	return $this->results;
}

//*** Function: getQuery, Purpose: Returns the last database query, for debugging ***
function getQuery() {
	return $this->theQuery;
}

//*** Function: getNumRows, Purpose: Return row count, MySQL version ***
function getNumRows($result = null){
	if ($result == null){
		return mysql_num_rows($this->results);
	}else{
		return mysql_num_rows($result);
	}
}

function getPagNumResults(){
	return $this->pagNumResults;
}

//*** Function: getInsertID, Purpose: Get the ID of insert, MySQL version ***
function getInsertID($result = null){
	if ($result == null){
		return mysql_insert_id($this->link);
	}else{
		return mysql_insert_id($result);
	}
}

//*** Function: fetchArray, Purpose: Get array of query results ***
function fetchArray($result) {
	return mysql_fetch_array($result,MYSQL_ASSOC);
}

//*** Function: listDBs, Purpose: List all DBs available ***
function listDBs(){
	$databases = Array();
	$list = mysql_list_dbs($this->link);
	while ($getDB = mysql_fetch_object($list)) {
	     $databases[] = $getDB->Database;
	}
	return $databases;
}

//*** Function: close, Purpose: Close the connection ***
function close() {
	//echo 'close';
	mysql_close($this->link);
}

//*** Function: paginate, Purpose: Paginate the current query ***
function paginate($bool = true,$perPage = 1){
	$this->withPag = $bool;
	if ($bool == true){
		$this->paginatorObj = new Paginator($this,$perPage);
	}
}

//*** Function: showNavLinks, Purpose: Echo the paginator's nav links ***
function showNavLinks(){
	$this->paginatorObj->showBox($this);
}

}


?>
