<?php
////////////////////////////////////////////////////////////////////////////////////////
// Class: sentry
// Purpose: Control access to pages
///////////////////////////////////////////////////////////////////////////////////////
require_once('SystemComponent.php');
class sentry extends SystemComponent {
	
	var $loggedin = false;	//	Boolean to store whether the user is logged in
	var $userdata;			//  Array to contain user's data
	
	function sentry(){
		session_start();
		header("Cache-control: private"); 
	}
	
	//======================================================================================
	// Log out, destroy session
	function logout(){
		unset($this->userdata);
		session_destroy();
		return true;
	}

	//======================================================================================
	// Log in, and either redirect to goodRedirect or badRedirect depending on success
	function checkLogin($user = '',$pass = '',$goodRedirect = '',$badRedirect = ''){

		// Include database and validation classes, and create objects
		require_once('DbConnector.php');
		require_once('Validator.php');
		$validate = new Validator();
		$loginConnector = SystemComponent::DB();
		
		// If user is not already logged in then check username and password
		if (!isset($_SESSION['user']) && !isset($_SESSION['pass'])) {	
			// Validate input
			if (!$validate->validateTextOnly($user)){return false;}
			if (!$validate->validateTextOnly($pass)){return false;}

			// Look up user in DB
			$getUser = $loginConnector->query("SELECT * FROM Users WHERE username = '$user' AND password = '$pass'");
			$this->userdata = $loginConnector->fetchArray($getUser);

			if ($loginConnector->getNumRows($getUser) > 0){
				// Login OK, store session details
				
				// Regenerate session ID
				if (function_exists('session_regenerate_id')) session_regenerate_id();

				// Log in
				$_SESSION["userid"] = $this->userdata['id'];
				$_SESSION["user"] = $user;
				$_SESSION["pass"] = $this->userdata['password'];
				$_SESSION["firstname"] = $this->userdata['firstname'];
				
				// Record user agent to make sure users don't get switched
				$_SESSION['HTTP_USER_AGENT'] = md5($_SERVER['HTTP_USER_AGENT']); 

				if ($goodRedirect) { 
					//header("Location: ".$goodRedirect."?".strip_tags(session_id())) ;
					header("Location: http://".$_SERVER['HTTP_HOST']. rtrim(dirname($_SERVER['PHP_SELF']), '/\\'). "/".$goodRedirect."?".strip_tags(session_id())) ;					
				}
				return true;

			}else{
				// Login BAD
				unset($this->userdata);
				if ($badRedirect) { 
					header("Location: ".$badRedirect) ;
				}		
				return false;
			}
		}			
	}


}	
?>